commit d3a00fe2c178e5959485446f8c8f2ac3ae2fa4cf
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu May 9 13:53:35 2024 +0530

    PS-9174 Failure in Protocol_classic::send_field_metadata
    
    https://perconadev.atlassian.net/browse/PS-9174
    
    Bug#35904044 mysql/mysql-server@271dcf231d0
    
    There may be a failure when returning metadata to the client for certain
    SQL queries involving dynamic parameters and subqueries in a SELECT
    clause. The fix is to avoid setting an item name that is a NULL pointer.
    
    Change-Id: I1abe206f97060c218de1ae23c63a4da80ffaaae5

diff --git a/sql/item_subselect.cc b/sql/item_subselect.cc
index 5569cabb900..60a24bb7a82 100644
--- a/sql/item_subselect.cc
+++ b/sql/item_subselect.cc
@@ -439,7 +439,10 @@ bool Item_subselect::fix_fields(THD *thd, Item **ref)
     {
       int ret= 0;
       (*ref)= substitution;
-      substitution->item_name= item_name;
+      if (item_name.is_set())
+      {
+        substitution->item_name = item_name;
+      }
       if (have_to_be_excluded)
 	engine->exclude();
       substitution= 0;

